<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ExternalTransactionID ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ExternalTransactionID extends AbstractStructArrayBase
{
    /**
     * The ExternalTransactionID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ExternalTransactionID[]
     */
    public $ExternalTransactionID;
    /**
     * Constructor method for ArrayOfJP_ExternalTransactionID
     * @uses ArrayOfJP_ExternalTransactionID::setExternalTransactionID()
     * @param \StructType\JP_ExternalTransactionID[] $externalTransactionID
     */
    public function __construct(array $externalTransactionID = array())
    {
        $this
            ->setExternalTransactionID($externalTransactionID);
    }
    /**
     * Get ExternalTransactionID value
     * @return \StructType\JP_ExternalTransactionID[]|null
     */
    public function getExternalTransactionID()
    {
        return $this->ExternalTransactionID;
    }
    /**
     * This method is responsible for validating the values passed to the setExternalTransactionID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExternalTransactionID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExternalTransactionIDForArrayConstraintsFromSetExternalTransactionID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ExternalTransactionIDExternalTransactionIDItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ExternalTransactionIDExternalTransactionIDItem instanceof \StructType\JP_ExternalTransactionID) {
                $invalidValues[] = is_object($arrayOfJP_ExternalTransactionIDExternalTransactionIDItem) ? get_class($arrayOfJP_ExternalTransactionIDExternalTransactionIDItem) : sprintf('%s(%s)', gettype($arrayOfJP_ExternalTransactionIDExternalTransactionIDItem), var_export($arrayOfJP_ExternalTransactionIDExternalTransactionIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExternalTransactionID property can only contain items of type \StructType\JP_ExternalTransactionID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExternalTransactionID value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ExternalTransactionID[] $externalTransactionID
     * @return \ArrayType\ArrayOfJP_ExternalTransactionID
     */
    public function setExternalTransactionID(array $externalTransactionID = array())
    {
        // validation for constraint: array
        if ('' !== ($externalTransactionIDArrayErrorMessage = self::validateExternalTransactionIDForArrayConstraintsFromSetExternalTransactionID($externalTransactionID))) {
            throw new \InvalidArgumentException($externalTransactionIDArrayErrorMessage, __LINE__);
        }
        $this->ExternalTransactionID = $externalTransactionID;
        return $this;
    }
    /**
     * Add item to ExternalTransactionID value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ExternalTransactionID $item
     * @return \ArrayType\ArrayOfJP_ExternalTransactionID
     */
    public function addToExternalTransactionID(\StructType\JP_ExternalTransactionID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ExternalTransactionID) {
            throw new \InvalidArgumentException(sprintf('The ExternalTransactionID property can only contain items of type \StructType\JP_ExternalTransactionID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExternalTransactionID[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ExternalTransactionID|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ExternalTransactionID|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ExternalTransactionID|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ExternalTransactionID|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ExternalTransactionID|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExternalTransactionID
     */
    public function getAttributeName()
    {
        return 'ExternalTransactionID';
    }
}
